
/* lp.h */

/*
 * Defines, and declarations for a
 * C => Fortran, RLaB => LAPACK interface.
 */

#ifndef RLAB_LP_H
#define RLAB_LP_H

#include "fi.h"

#ifdef HAVE_FORTRAN_UND_BACK

#define RGETRF rgetrf_
#define XGETRF xgetrf_
#define RGETRI rgetri_
#define XGETRI xgetri_
#define RGETRS rgetrs_
#define XGETRS xgetrs_
#define RGECON rgecon_
#define XGECON xgecon_
#define RGEBAL rgebal_
#define XGEBAL xgebal_
#define RGEQRF rgeqrf_
#define XGEQRF xgeqrf_
#define RORGQR rorgqr_
#define XUNGQR xungqr_
#define RGESVD rgesvd_
#define XGESVD xgesvd_
#define RPOTRF rpotrf_
#define XPOTRF xpotrf_
#define RGEEV rgeev_
#define XGEEV xgeev_
#define RGEHRD rgehrd_
#define XGEHRD xgehrd_
#define RORGHR rorghr_
#define XUNGHR xunghr_
#define RSYGV rsygv_
#define XHEGV xhegv_
#define RGEQPF rgeqpf_
#define XGEQPF xgeqpf_
#define RSYEV rsyev_
#define XHEEV xheev_
#define RGEGV rgegv_
#define XGEGV xgegv_
#define RGELSS rgelss_
#define XGELSS xgelss_
#define RGETRF rgetrf_
#define XGETRF xgetrf_
#define RGEES rgees_
#define XGEES xgees_
#define RTREXC rtrexc_
#define XTREXC xtrexc_
#define RTRSYL rtrsyl_
#define XTRSYL xtrsyl_
#define RSYTRF rsytrf_
#define XSYTRF xsytrf_
#define RSYCON rsycon_
#define XSYCON xsycon_
#define RSYTRS rsytrs_
#define XSYTRS xsytrs_
#define XHETRF xhetrf_
#define XHETRS xhetrs_
#define XHECON xhecon_
#define RLANGE rlange_
#define XLANGE xlange_
#define RLAMCH rlamch_

#endif

#ifdef HAVE_FORTRAN_UND_FRONT

#define RGETRF _rgetrf
#define XGETRF _xgetrf
#define RGETRI _rgetri
#define XGETRI _xgetri
#define RGETRS _rgetrs
#define XGETRS _xgetrs
#define RGECON _rgecon
#define XGECON _xgecon
#define RGEBAL _rgebal
#define XGEBAL _xgebal
#define RGEQRF _rgeqrf
#define XGEQRF _xgeqrf
#define RORGQR _rorgqr
#define XUNGQR _xungqr
#define RGESVD _rgesvd
#define XGESVD _xgesvd
#define RPOTRF _rpotrf
#define XPOTRF _xpotrf
#define RGEEV _rgeev
#define XGEEV _xgeev
#define RGEHRD _rgehrd
#define XGEHRD _xgehrd
#define RORGHR _rorghr
#define XUNGHR _xunghr
#define RSYGV _rsygv
#define XHEGV _xhegv
#define RGEQPF _rgeqpf
#define XGEQPF _xgeqpf
#define RSYEV _rsyev
#define XHEEV _xheev
#define RGEGV _rgegv
#define XGEGV _xgegv
#define RGELSS _rgelss
#define XGELSS _xgelss
#define RGETRF _rgetrf
#define XGETRF _xgetrf
#define RGEES _rgees
#define XGEES _xgees
#define RTREXC _rtrexc
#define XTREXC _xtrexc
#define RTRSYL _rtrsyl
#define XTRSYL _xtrsyl
#define RSYTRF _rsytrf
#define XSYTRF _xsytrf
#define RSYCON _rsycon
#define XSYCON _xsycon
#define RSYTRS _rsytrs
#define XSYTRS _xsytrs
#define XHETRF _xhetrf
#define XHETRS _xhetrs
#define XHECON _xhecon
#define RLANGE _rlange
#define XLANGE _xlange
#define RLAMCH _rlamch

#endif

#ifdef HAVE_FORTRAN_UPPERCASE
/* Do nothing, the existing code is OK */
#endif

#ifdef HAVE_FORTRAN_LOWERCASE

#define RGETRF rgetrf
#define XGETRF xgetrf
#define RGETRI rgetri
#define XGETRI xgetri
#define RGETRS rgetrs
#define XGETRS xgetrs
#define RGECON rgecon
#define XGECON xgecon
#define RGEBAL rgebal
#define XGEBAL xgebal
#define RGEQRF rgeqrf
#define XGEQRF xgeqrf
#define RORGQR rorgqr
#define XUNGQR xungqr
#define RGESVD rgesvd
#define XGESVD xgesvd
#define RPOTRF rpotrf
#define XPOTRF xpotrf
#define RGEEV rgeev
#define XGEEV xgeev
#define RGEHRD rgehrd
#define XGEHRD xgehrd
#define RORGHR rorghr
#define XUNGHR xunghr
#define RSYGV rsygv
#define XHEGV xhegv
#define RGEQPF rgeqpf
#define XGEQPF xgeqpf
#define RSYEV rsyev
#define XHEEV xheev
#define RGEGV rgegv
#define XGEGV xgegv
#define RGELSS rgelss
#define XGELSS xgelss
#define RGETRF rgetrf
#define XGETRF xgetrf
#define RGEES rgees
#define XGEES xgees
#define RTREXC rtrexc
#define XTREXC xtrexc
#define RTRSYL rtrsyl
#define XTRSYL xtrsyl
#define RSYTRF rsytrf
#define XSYTRF xsytrf
#define RSYCON rsycon
#define XSYCON xsycon
#define RSYTRS rsytrs
#define XSYTRS xsytrs
#define XHETRF xhetrf
#define XHETRS xhetrs
#define XHECON xhecon
#define RLANGE rlange
#define XLANGE xlange
#define RLAMCH rlamch

#endif

extern F_INT RGETRF ();
extern F_INT XGETRF ();
extern F_INT RGETRI ();
extern F_INT XGETRI ();
extern F_INT RGETRS ();
extern F_INT XGETRS ();
extern F_INT RGECON ();
extern F_INT XGECON ();
extern F_INT RGEBAL ();
extern F_INT XGEBAL ();
extern F_INT RGEQRF ();
extern F_INT XGEQRF ();
extern F_INT RORGQR ();
extern F_INT XUNGQR ();
extern F_INT RGESVD ();
extern F_INT XGESVD ();
extern F_INT RPOTRF ();
extern F_INT XPOTRF ();
extern F_INT RGEEV ();
extern F_INT XGEEV ();
extern F_INT RGEHRD ();
extern F_INT XGEHRD ();
extern F_INT RORGHR ();
extern F_INT XUNGHR ();
extern F_INT RSYGV ();
extern F_INT XHEGV ();
extern F_INT RGEQPF ();
extern F_INT XGEQPF ();
extern F_INT RSYEV ();
extern F_INT XHEEV ();
extern F_INT RGEGV ();
extern F_INT XGEGV ();
extern F_INT RGELSS ();
extern F_INT XGELSS ();
extern F_INT RGETRF ();
extern F_INT XGETRF ();
extern F_INT RGEES ();
extern F_INT XGEES ();
extern F_INT RTREXC ();
extern F_INT XTREXC ();
extern F_INT RTRSYL ();
extern F_INT XTRSYL ();
extern F_INT RSYTRF ();
extern F_INT XSYTRF ();
extern F_INT RSYCON ();
extern F_INT XSYCON ();
extern F_INT RSYTRS ();
extern F_INT XSYTRS ();
extern F_INT XHETRF ();
extern F_INT XHETRS ();
extern F_INT XHECON ();

extern F_DOUBLE RLANGE ();
extern F_DOUBLE XLANGE ();
extern F_DOUBLE RLAMCH ();

#endif /* RLAB_LP_H */
